<?php
/* 
Plugin Name: Lazy Gallery 
Plugin URI: http://www.lazyboy.dk
Description: Gallery plugin for Wordpress 1.5+
Author: Nicholas Bruun Jespersen
Author URI: http://www.lazyboy.dk
Version: 0.4
*/

/*  Copyright 2004  Nicholas Bruun Jespersen  (For questions join discussion on www.lazyboy.dk)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// Globals - Do not tamper with these
global $gallery_root, $gallery_address, $file, $excluded_folders, $pictwidth, $pictheight, $thumbwidth, $thumbheight, $gallery_width, $gallery_sidebar;

global $debug;
$debug=1;

function debug( $string ){
	global $debug;
	if( $debug == 1){
		echo $string;
	}
}

// ---------- Settings ----------
// Configure these settings, to use the gallery.
 
// Your gallery folder (this is where your pictures and picture folders are located).
$gallery_address = '/jim-weller/images/gallery/'; // must end in slash

// Sidebar position
$gallery_sidebar = ''; // left or right or '' (empty)

// Add foldernames to exclude. (add more lines like this on more excludes.)
$excluded_folders[] = 'cgi-bin';
$excluded_folders[] = '.old';

// Picture size
$pictwidth = 400;
$pictheight = 400;

// Thumbnail size
$thumbwidth = 110;
$thumbheight = 110;
// ---------- Settings end ----------

// Do not edit below this line 
$gallery_root = '/home/jimwelle/jims/chronological/';
$gallery_address = 'http://'.$_SERVER['HTTP_HOST'].$gallery_address;

function showGallery() {
	global $file,$gallery_root;

	$file = stripslashes(rawurldecode($_GET['file']));
	//$file = substr($_SERVER['REQUEST_URI'],strlen('/gallery/'));
	//debug("file=$file<br>");

	if (!validateFile())
	{
		echo 'Invalid folder or file';
		return;
	}


        echo "<div class=\"storycontent\">";
	createNavigation($file);
	if( is_dir( $gallery_root . $file ) )
	{
		//Display Dir(s) (if any)
		showDirs($file);


		//Display Thumb(s) (if any)
		showThumbs($file,1);

	} else {
		showSlide($file);
		showThumbs(dirname($file),0);
	}
        echo "</div>";
}


// we know this is a dir from is_dir in showGallery()
function showDirs($theFile) {

	global $gallery_root, $excluded_folders;
	
	$dirs = array();
	chdir($gallery_root.$theFile);
	if ($dir_content = opendir($gallery_root.$theFile)) {		
		while ( false !== ($dir = readdir($dir_content)) ) {
			if (is_dir($dir) && !in_array($dir, $excluded_folders) && $dir!='.' && $dir!='..' ) {
				$dirs[]=$dir;
			}
		}
   	}
	rsort($dirs);

	echo "<ul>";
	foreach( $dirs as $dir ){
		
		if( $theFile != '' ){
			$mf = $theFile . '/';
		}
		$readmeTxt = "";
	
		echo "<li>";
		//if(  ( file_exists($dir . "/" . "readme.txt") ) &&  ( $readmeTxt = file_get_contents($dir . "/" . "readme.txt") ) )
		//	echo '<a href="'. '/gallery/' . $mf  . $dir .   '">'.$dir.'</a> ' . substr($readmeTxt,0,50)  . "\n";
		//else
			echo '<a href="'. '/gallery/' . $mf  . $dir .   '">'.$dir.'</a>' . "\n";
		echo "</li>";
	}	
	echo "</ul>";	
}

function showSlide($slidefile) {
	global $gallery_root;
	if( is_file($gallery_root.$slidefile) ){
		echo toHtml($slidefile);
	}
}

function toHtml($slidefile){
	global $gallery_root,$gallery_address;

	$index=0;
	$total=0;
	$files = array();

	chdir($gallery_root.dirname($slidefile));

	$theFile = basename(dirname($slidefile));


	# first count image files and mark ours
	if ($dir_content = opendir($gallery_root.dirname($slidefile))) {
		while ( false !== ($f = readdir($dir_content)) ) {
			if ( is_file($f) && preg_match("/^[^(th_)].*(\.jpg|\.gif|\.png|\.jpeg)$/i", $f))
				$files[] = $f;
		}
	}
	$total=0;

	if( $theFile=="0moblog" )
	{
		rsort($files);
	}
	else
	{
		sort($files);
	}

	foreach( $files as $f ){
		if( strcmp(basename($slidefile),$f) == 0 )
			$index=$total;
		$total+=1;
	}

	$imgref = "<img  alt=\"$slidefile\" style=\"float: left;\" src=\"" . $gallery_address . $slidefile . "\" />";

	$next='';
	$val=0;
	 if( $index != ($total-1) )
	 {
	 	$val= $index + 1;
 		$imgref = "<a href=\"/gallery/" . dirname($slidefile) . "/" . $files[$val] . "\"><img  alt=\"$slidefile\" src=\"" . $gallery_address . $slidefile . "\" /></a>";
	 }

	

	return "<div style=\"margin-top: 10px; float: left; width: 640px; height: 640px; text-align: center; display: table-cell; min-height: 12em; vertical-align: middle;\">$imgref</div>";
 

}

function showThumbs($theFile,$showFirst) {
	
	global $gallery_root, $thumbwidth, $thumbheight, $gallery_address;
	
	$imgFiles=array();
	chdir($gallery_root.$theFile);
	if ($dir_content = opendir($gallery_root.$theFile)) {
		while ( false !== ($file = readdir($dir_content)) ) {
			if ( is_file($file) )
				if(preg_match("/^[^(th_)].*(\.jpg|\.gif|\.png|\.jpeg)$/i", $file))
					$imgfiles[] = $file;
		}
	}

	if(isset($imgfiles))
	{
		if( $theFile == "0moblog")
		{
			rsort($imgfiles);
		}
		else
		{
			sort($imgfiles);
		}
		if( $showFirst == 1 ){
			showSlide("$theFile/".$imgfiles[0]);
		}
		foreach ($imgfiles as $img)
		{
			echo "<a href=\"/gallery/$theFile/$img\"><img  alt=\"$slidefile\" height=\"60\" class=\"moblog\" src=\"$gallery_address$theFile"."/th_"."$img\" /></a>\n";
		}
	}
}

// Validates file variable
function validateFile() {

	global $excluded_folders, $file;
	
	// validate dir
	if ( strstr($file, '..') || strstr($file, '%2e%2e') )
		return false;
		
	foreach ($excluded_folders as $folder)
	{
		if ( strstr($file, $folder) )
		return false;
	}
	return true;
}

// don't know if file or dir
function createNavigation($theFile)
{


	//echo $theFile;
	$nav = split('/', $theFile);
	array_pop($nav);
	$g = $nav[0];
	echo "<p><a href=\"/gallery.html\">Photos</a>";

	foreach ( $nav as $n )
	{
		echo " / <a href=\"/gallery/$g\">".$n."</a>";
		$g = $g . "/" . $n;
	}
	if( preg_match("/^.*(\.jpg|\.gif|\.png|\.jpeg)$/i", $theFile) )
	{
		echo " / <a href=\"/jim-weller/images/gallery/$theFile\"><i>" . basename($theFile) . "</i></a>";
	}
	else
	{
		echo " / <a href=\"/gallery/$theFile\"><i>" . basename($theFile) . "</i></a>";
	}
	echo "</p>";


	if( $theFile == "" )
	{
		echo "<p>Here are my home photos. They are listed newest first. Click a gallery to see its images. Click on a thumbnail to see an image. Click the image to advance to the next image. I also keep a gallery of <a href=\"http://www.jimweller.com/gallery/0moblog\">mobile</a> pictures, pictures shot quickly or on a mobile device.</p>";
	}
	else
	{
		echo "<p><i>Click the current image to advance to the next image. Click a thumbnail to see the full size image.</i></p>";
	}
}

